package de.intevation.gnv.transition;

import de.intevation.gnv.state.State;

import java.io.Serializable;

import org.w3c.dom.Node;

/**
 *
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public interface Transition extends Serializable{

    /**
     * Returns the ID of the State from which the Transition could be used
     * @return the ID of the State from which the Transition could be used
     */
    public String getFrom();

    /**
     * Returns the ID of the State where it is possible to go as next.
     * @return the ID of the State where it is possible to go as next.
     */
    public String getTo();

    /**
     * Determines if it is possible to go along this Transition or not.
     * @param state the current State
     * @return
     */
    public boolean isValid(State state);

    /**
     * Configures the Transition.
     * @param configuration
     */
    public void setup(Node configuration);

}
